<html>
<head>
<title>OgreMemoryStdAlloc.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMemoryStdAlloc.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMemoryStdAlloc_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __MemoryStdAlloc_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __MemoryStdAlloc_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;memory&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAlignedAllocator_8h.html">OgreAlignedAllocator.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreMemoryTracker_8h.html">OgreMemoryTracker.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 <span class="preprocessor">#if OGRE_MEMORY_ALLOCATOR == OGRE_MEMORY_ALLOCATOR_STD</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00055"></a><a class="code" href="classOgre_1_1StdAllocPolicy.html">00055</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StdAllocPolicy.html" title="A &quot;standard&quot; allocation policy for use with AllocatedObject and STLAllocator.">StdAllocPolicy</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1StdAllocPolicy.html#af94797b160779ff0f2e95eb0ba8d64a5">00058</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span>* allocateBytes(<span class="keywordtype">size_t</span> count, 
<a name="l00059"></a>00059 #<span class="keywordflow">if</span> <a class="code" href="OgrePrerequisites_8h.html#a7087d2ed9eb4e1f820fd300d85df375d">OGRE_MEMORY_TRACKER</a>
<a name="l00060"></a>00060             <span class="keyword">const</span> <span class="keywordtype">char</span>* file = 0, <span class="keywordtype">int</span> line = 0, <span class="keyword">const</span> <span class="keywordtype">char</span>* func = 0
<a name="l00061"></a>00061 #<span class="keywordflow">else</span>
<a name="l00062"></a>00062             <span class="keyword">const</span> <span class="keywordtype">char</span>*  = 0, <span class="keywordtype">int</span>  = 0, <span class="keyword">const</span> <span class="keywordtype">char</span>* = 0
<a name="l00063"></a>00063 #endif
<a name="l00064"></a>00064             )
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066             <span class="keywordtype">void</span>* ptr = malloc(count);
<a name="l00067"></a>00067 <span class="preprocessor">#if OGRE_MEMORY_TRACKER</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>            <span class="comment">// this alloc policy doesn&#39;t do pools</span>
<a name="l00069"></a>00069             MemoryTracker::get()._recordAlloc(ptr, count, 0, file, line, func);
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>            <span class="keywordflow">return</span> ptr;
<a name="l00072"></a>00072         }
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="classOgre_1_1StdAllocPolicy.html#abcce32679ffd71fbcc8533f79b4fa16d">00074</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> deallocateBytes(<span class="keywordtype">void</span>* ptr)
<a name="l00075"></a>00075         {
<a name="l00076"></a>00076 <span class="preprocessor">#if OGRE_MEMORY_TRACKER</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>            MemoryTracker::get()._recordDealloc(ptr);
<a name="l00078"></a>00078 <span class="preprocessor">#endif</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>            free(ptr);
<a name="l00080"></a>00080         }
<a name="l00081"></a>00081 
<a name="l00083"></a><a class="code" href="classOgre_1_1StdAllocPolicy.html#ae16a3e17c2643b6af6a4e4f37848fa5b">00083</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">size_t</span> getMaxAllocationSize()
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             <span class="keywordflow">return</span> std::numeric_limits&lt;size_t&gt;::max();
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087     <span class="keyword">private</span>:
<a name="l00088"></a>00088         <span class="comment">// no instantiation</span>
<a name="l00089"></a><a class="code" href="classOgre_1_1StdAllocPolicy.html#a0af98d59c61ea723e837b1a6e7567f55">00089</a>         <a class="code" href="classOgre_1_1StdAllocPolicy.html" title="A &quot;standard&quot; allocation policy for use with AllocatedObject and STLAllocator.">StdAllocPolicy</a>()
<a name="l00090"></a>00090         { }
<a name="l00091"></a>00091     };
<a name="l00092"></a>00092 
<a name="l00105"></a>00105     <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> Alignment = 0&gt;
<a name="l00106"></a><a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html">00106</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html" title="A &quot;standard&quot; allocation policy for use with AllocatedObject and STLAllocator, which aligns memory at ...">StdAlignedAllocPolicy</a>
<a name="l00107"></a>00107     {
<a name="l00108"></a>00108     <span class="keyword">public</span>:
<a name="l00109"></a>00109         <span class="comment">// compile-time check alignment is available.</span>
<a name="l00110"></a>00110         <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#aab20b04cef620b603f5877fd48b53e5b">IsValidAlignment</a>
<a name="l00111"></a><a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#aab20b04cef620b603f5877fd48b53e5b">00111</a>             [Alignment &lt;= 128 &amp;&amp; ((Alignment &amp; (Alignment-1)) == 0) ? +1 : -1];
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#aa5c16bd66a3e8dbbd9482e7dd07ec9db">00113</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span>* <a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#aa5c16bd66a3e8dbbd9482e7dd07ec9db">allocateBytes</a>(<span class="keywordtype">size_t</span> count, 
<a name="l00114"></a>00114 #<span class="keywordflow">if</span> <a class="code" href="OgrePrerequisites_8h.html#a7087d2ed9eb4e1f820fd300d85df375d">OGRE_MEMORY_TRACKER</a>
<a name="l00115"></a>00115             <span class="keyword">const</span> <span class="keywordtype">char</span>* file = 0, <span class="keywordtype">int</span> line = 0, <span class="keyword">const</span> <span class="keywordtype">char</span>* func = 0
<a name="l00116"></a>00116 #<span class="keywordflow">else</span>
<a name="l00117"></a>00117             <span class="keyword">const</span> <span class="keywordtype">char</span>*  = 0, <span class="keywordtype">int</span>  = 0, <span class="keyword">const</span> <span class="keywordtype">char</span>* = 0
<a name="l00118"></a>00118 #endif
<a name="l00119"></a>00119             )
<a name="l00120"></a>00120         {
<a name="l00121"></a>00121             <span class="keywordtype">void</span>* ptr = Alignment ? <a class="code" href="classOgre_1_1AlignedMemory.html#a215ddaa2cf45c92ec39560dd43bed7b6" title="Allocate memory with given alignment.">AlignedMemory::allocate</a>(count, Alignment)
<a name="l00122"></a>00122                 : AlignedMemory::allocate(count);
<a name="l00123"></a>00123 <span class="preprocessor">#if OGRE_MEMORY_TRACKER</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>            <span class="comment">// this alloc policy doesn&#39;t do pools</span>
<a name="l00125"></a>00125             MemoryTracker::get()._recordAlloc(ptr, count, 0, file, line, func);
<a name="l00126"></a>00126 <span class="preprocessor">#endif</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>            <span class="keywordflow">return</span> ptr;
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#a6ee5fb2c88d4c42673126c6ec355deed">00130</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#a6ee5fb2c88d4c42673126c6ec355deed">deallocateBytes</a>(<span class="keywordtype">void</span>* ptr)
<a name="l00131"></a>00131         {
<a name="l00132"></a>00132 <span class="preprocessor">#if OGRE_MEMORY_TRACKER</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>            MemoryTracker::get()._recordDealloc(ptr);
<a name="l00134"></a>00134 <span class="preprocessor">#endif</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>            <a class="code" href="classOgre_1_1AlignedMemory.html#aec9665c128b282869284a6025520adee" title="Deallocate memory that allocated by this class.">AlignedMemory::deallocate</a>(ptr);
<a name="l00136"></a>00136         }
<a name="l00137"></a>00137 
<a name="l00139"></a><a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#a6222b252df6d4f2bde65530dbb30ad5b">00139</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#a6222b252df6d4f2bde65530dbb30ad5b" title="Get the maximum size of a single allocation.">getMaxAllocationSize</a>()
<a name="l00140"></a>00140         {
<a name="l00141"></a>00141             <span class="keywordflow">return</span> std::numeric_limits&lt;size_t&gt;::max();
<a name="l00142"></a>00142         }
<a name="l00143"></a>00143     <span class="keyword">private</span>:
<a name="l00144"></a>00144         <span class="comment">// No instantiation</span>
<a name="l00145"></a><a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#acde47348bf3ef90847c00e82e8be5e9c">00145</a>         <a class="code" href="classOgre_1_1StdAlignedAllocPolicy.html#acde47348bf3ef90847c00e82e8be5e9c">StdAlignedAllocPolicy</a>()
<a name="l00146"></a>00146         { }
<a name="l00147"></a>00147     };
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="preprocessor">#endif</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>
<a name="l00153"></a>00153 }<span class="comment">// namespace Ogre</span>
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif // __MemoryStdAlloc_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
